local classes = require("lua/explosionsNG/helpers/classes")
local ShockwaveExplosiveStats = require("lua/explosionsNG/explosives/contained/shockwave/ShockwaveExplosiveStats")

--- @class LightningExplosiveStats : ShockwaveExplosiveStats
local LightningExplosiveStats = classes.newClass(ShockwaveExplosiveStats)

--- __Constructor__
--- @param explosiveOptions LightningExplosiveOptions The explosive options to get the stats of. Currently ignored
--- @return LightningExplosiveStats The constructed instance
function LightningExplosiveStats:new(explosiveOptions)
  local self = classes.setmetatable(ShockwaveExplosiveStats:new(--[[--- @not nil ]] explosiveOptions.shockwave), LightningExplosiveStats)
  return self
end

return LightningExplosiveStats
