local classes = require("lua/explosionsNG/helpers/classes")
local ShockwaveExplosiveStats = require("lua/explosionsNG/explosives/contained/shockwave/ShockwaveExplosiveStats")

--- @class MineExplosiveStats : ShockwaveExplosiveStats
local MineExplosiveStats = classes.newClass(ShockwaveExplosiveStats)

--- __Constructor__
--- @param explosiveOptions MineExplosiveOptions The explosive options to get the stats of
--- @return MineExplosiveStats The constructed instance
function MineExplosiveStats:new(explosiveOptions)
  if not explosiveOptions.shockwaveExplosiveOptions then
    error("Shockwave explosive options cannot be nil!")
  end

  local self = classes.setmetatable(ShockwaveExplosiveStats:new(--[[--- @not nil ]] explosiveOptions.shockwaveExplosiveOptions), MineExplosiveStats)
  return self
end

return MineExplosiveStats
