local classes = require("lua/explosionsNG/helpers/classes")
local ExplosiveStats = require("lua/explosionsNG/explosives/base/ExplosiveStats")

--- @class ConvergenceExplosiveStats : ExplosiveStats<ConvergenceExplosiveOptions>
local ConvergenceExplosiveStats = classes.newClass(ExplosiveStats)

--- @return number The absolute energy stat
--- @see ExplosiveStats#getAbsoluteEnergyStat
function ConvergenceExplosiveStats:getAbsoluteEnergyStat()
  return math.huge
end

--- @return number The absolute range stat
--- @see ExplosiveStats#getAbsoluteRangeStat
function ConvergenceExplosiveStats:getAbsoluteRangeStat()
  return math.huge
end

--- @return number The absolute accuracy stat
--- @see ExplosiveStats#getAbsoluteAccuracyStat
function ConvergenceExplosiveStats:getAbsoluteAccuracyStat()
  return 1
end

--- @return number The absolute attack rate stat
--- @see ExplosiveStats#getAbsoluteAttackRateStat
function ConvergenceExplosiveStats:getAbsoluteAttackRateStat()
  return 1
end

--- __Constructor__
--- @param explosiveOptions ConvergenceExplosiveOptions The explosive options to get the stats of
--- @return ConvergenceExplosiveStats The constructed instance
function ConvergenceExplosiveStats:new(explosiveOptions)
  local self = classes.setmetatable(ExplosiveStats:new(explosiveOptions, "coverage"), ConvergenceExplosiveStats)
  return self
end

return ConvergenceExplosiveStats
