local classes = require("lua/explosionsNG/helpers/classes")
local ShockwaveExplosiveStats = require("lua/explosionsNG/explosives/contained/shockwave/ShockwaveExplosiveStats")

--- @class SupernovaExplosiveStats : ShockwaveExplosiveStats
local SupernovaExplosiveStats = classes.newClass(ShockwaveExplosiveStats)

--- __Constructor__
--- @param explosiveOptions SupernovaExplosiveOptions The explosive options to get the stats of
--- @return SupernovaExplosiveStats The constructed instance
function SupernovaExplosiveStats:new(explosiveOptions)
  local self = classes.setmetatable(ShockwaveExplosiveStats:new(explosiveOptions.shockwaveExplosiveOptions), SupernovaExplosiveStats)
  return self
end

return SupernovaExplosiveStats
