--- This file contains a list of interface types that classes can implement.
--- Unfortunately, documentation for individual methods within the interface is not feasible (as they must be defined on
--- the same line).

--- @class Celestial<T> : { update: (fun(self: Celestial<T>, dt: number): void), isDead: (fun(self: Celestial<T>): boolean), destroy: (fun(self: Celestial<T>): void), getEvents: (fun(self: Celestial<T>): Registrable<T>)  }

--- @class DynamicObject : { update: (fun(self: DynamicObject, dt: number): void), setPosition: (fun(self: DynamicObject, newPosition: LuaVec3): void) }

--- @class Path : { getCurrentPosition: (fun(self: Path): LuaVec3) }

--- @class Registrable<T> : { registerEventHandler: (fun(self: Registrable<T>, event: T, handler: fun(context: any): void): void), unregisterEventHandler: (fun(self: Registrable<T>, event: T, handler: fun(context: any): void): void) }

--- @class Evented<T> : { getEvents: (fun(self: Evented<T>): Registrable<T>) }

--- @alias AttackPatternEvent "started" | "vehicleAffected" | "finished"
--- @class AttackPattern : { update: (fun(self: AttackPattern, dt: number): void), destroy: (fun(self: AttackPattern): void), getEvents: (fun(self: Evented<AttackPatternEvent>): Registrable<AttackPatternEvent>) }
--- @field protected events Events<AttackPatternEvent> The list of registrable events

--- @class EventedDynamicObject<T> : { getEvents: (fun(self: Evented<T>): Registrable<T>), update: (fun(self: DynamicObject, dt: number): void), setPosition: (fun(self: DynamicObject, newPosition: LuaVec3): void) }

--- @class VehicularEffect : { affect: (fun(self: VehicularEffect, vehicle: Vehicle, dt: number): void), isSource: (fun(self: VehicularEffect, sourceId: string): boolean), isActive: (fun(self: VehicularEffect): boolean), isInfinite: (fun(self: VehicularEffect): boolean), completeInfiniteEffect: (fun(self: VehicularEffect, vehicle: Vehicle): void) }