--- A facade that exposes functions via the usual Lua method of exposing APIs.
--- This acts similarly to a 'barrel' file, and any file within this store should NOT be accessed directly, rather, they
--- should go through this file inside.

local explosivesStore = require("lua/explosionsNG/stores/explosives/store")
local explosivesMapper = require("lua/explosionsNG/stores/explosives/mapper")

return {
  createNewExplosive = explosivesStore.createNewExplosive,
  getPresetsForExplosive = explosivesStore.getPresetsForExplosive,
  getExplosives = explosivesStore.getExplosives,
  getBoundingArea = explosivesStore.getBoundingArea,
  getAbsoluteExplosivePresetStats = explosivesStore.getAbsoluteExplosivePresetStats,
  getListOfExplosives = explosivesMapper.getListOfExplosives
}