angular.module("beamng.apps")
  /**
   * @ngdoc directive
   * @name beamng.apps:engButton
   * @description A button which provides styling for a few variants within the mod
   * @param {string} text The text to display on the button
   * @param {ButtonVariant} [variant] The variant of the button to use. Optional and defaults to `"primary"`.
   * @param {boolean} [disabled] Whether the button is disabled and cannot be clicked. Optional and defaults to `false`.
   * @param {() => void} onClick A callback function to call when the button is clicked
   */
  .directive("engButton", [() => {
    return {
      templateUrl: "../../modules/apps/ExplosionController/components/button/button.html",
      restrict: "E",
      transclude: true,
      scope: {
        text: "<",
        variant: "<",
        disabled: "<",
        onClick: "<"
      },
      link: $scope => {
        $scope.variant = $scope.variant || "primary";
        $scope.disabled = $scope.disabled || false;
      }
    }
  }]);