angular.module("beamng.apps")
  /**
   * @ngdoc directive
   * @name beamng.apps:engDropdown
   * @description A dropdown list that allows selecting multiple options from a list
   * @param {string} label A label to display
   * @param {Option[]} model A list of currently selected options
   * @param {Option[]} options A list of all options
   * @param {boolean} [invalid] Whether the dropdown state is invalid. Defaults to `false`.
   * @param {string[]} [errors] A list of errors to show. Defaults to an empty list.
   * @param {string} [placeholder] An optional placeholder to show when no items are selected
   * @param {boolean} [disabled] Whether the dropdown is disabled. Defaults to `false`.
   * @param {(options: Option[]) => void} onChange A callback function to call when the list of options is updated. The
   * new list is given in the callback and will be called _before_ the changes are reflected in the {@link model}.
   */
  .directive("engDropdown", [() => {
    return {
      templateUrl: "../../modules/apps/ExplosionController/components/dropdown/dropdown.html",
      restrict: "E",
      transclude: true,
      scope: {
        label: "<",
        model: "=",
        options: "<",
        invalid: "<",
        errors: "<",
        placeholder: "<",
        disabled: "<",
        onChange: "<"
      },
      link: $scope => {
        $scope.invalid = $scope.invalid || false;
        $scope.errors = $scope.errors || [];
        $scope.disabled = $scope.disabled || false;
      }
    }
  }]);