angular.module("beamng.apps")
  /**
   * @ngdoc directive
   * @name beamng.apps:engExplosiveOverview
   * @description Displays an overview of an {@link ConfiguredExplosive}
   * @param {ConfiguredExplosive | null} explosive The configured explosive to show an overview of. This can be `null`
   * @param {() => void} openClick A callback function to call when the explosive is clicked
   * @param {() => void} [deleteClick] A callback function to call when the `delete` button is clicked. This is not
   * required (and will be ignored) if the {@link explosive} is `null`.
   * @param {() => void} [previewClick] A callback function to call when the `preview` button is clicked. This is not
   * required (and will be ignored) if the {@link explosive} is `null`.
   */
  .directive("engExplosiveOverview", [() => {
    return {
      templateUrl: "../../modules/apps/ExplosionController/components/explosive-overview/explosive-overview.html",
      restrict: "E",
      scope: {
        explosive: "<",
        openClick: "&",
        deleteClick: "&",
        previewClick: "&"
      },
    }
  }])