angular.module("beamng.apps")
  /**
   * @ngdoc directive
   * @name beamng.apps:engExplosive
   * @description Displays a detailed view of a {@link ConfiguredExplosive} object
   * @param {ConfiguredExplosive} explosive The explosive to display
   * @param {ButtonControls} cycleExplosives A set of boolean values for controlling whether the previous and next
   * buttons for the explosive banner are disabled and cannot be clicked by the user
   * @param {ButtonControls} cyclePresets A set of boolean values for controlling whether the previous and next buttons
   * for the preset banner are disabled and cannot be clicked by the user
   * @param {HorizontalDirection} explosiveAnimationDirection The direction for which the explosive banner's text will
   * animate from
   * @param {HorizontalDirection} presetAnimationDirection The direction for which the explosive's preset banner's text
   * will animate from
   * @param {boolean} [locked] Whether the explosive is locked and cannot be selected
   * @param {() => void} nextExplosiveClick A callback function to call when the `previous` explosive arrow is clicked
   * @param {() => void} previousExplosiveClick A callback function to call when the `next` explosive arrow is clicked
   * @param {() => void} nextPresetClick A callback function to call when the `previous` preset arrow is clicked
   * @param {() => void} previousPresetClick A callback function to call when the `next` preset arrow is clicked
   * @param {() => void} selectClick A callback function to call when the `select` button is clicked
   * @param {() => void} backClick A callback function to call when the `back` button is clicked
   */
  .directive("engExplosive", [() => {
    return {
      templateUrl: "../../modules/apps/ExplosionController/components/explosive/explosive.html",
      restrict: "E",
      scope: {
        explosive: "<",
        cycleExplosives: "<",
        cyclePresets: "<",
        explosiveAnimationDirection: "<",
        presetAnimationDirection: "<",
        locked: "<",
        nextExplosiveClick: "<",
        previousExplosiveClick: "<",
        nextPresetClick: "<",
        previousPresetClick: "<",
        selectClick: "<"
      }
    }
  }])