angular.module("beamng.apps")
  /**
   * @ngdoc directive
   * @name beamng.apps:engIconButton
   * @description A button which contains an icon, rather than text
   * @param {string} icon The name of the Material icon to use
   * @param {boolean} [disabled] Whether the button is disabled and cannot be clicked. Optional and defaults to `false`.
   * @param {IconButtonSize} [size] The size of the button. Defaults to `"medium"`.
   * @param {() => void} onClick A callback function to call when the button is clicked
   */
  .directive("engIconButton", [() => {
    return {
      templateUrl: "../../modules/apps/ExplosionController/components/icon-button/icon-button.html",
      restrict: "E",
      transclude: true,
      scope: {
        icon: "<",
        size: "<",
        disabled: "<",
        onClick: "<"
      },
      link: $scope => {
        $scope.disabled = $scope.disabled || false;
        $scope.size = $scope.size || "medium";
      }
    }
  }]);