angular.module("beamng.apps")
  /**
   * @ngdoc directive
   * @name beamng.apps:engPanel
   * @description Provides a container with a header which additionally has main and footer content elements projected
   * into it. Use the `<engPanelContent>` and `<engPanelFooter>` to inject main and footer content respectively.
   * The `<engPanelActionBar>` is optional and should be used for action bars below the title.
   * @param {string} title The title to put in the header of the panel
   */
  .directive("engPanel", [() => {
    return {
      templateUrl: "../../modules/apps/ExplosionController/components/panel/panel.html",
      restrict: "E",
      transclude: {
        actionBar: "?engPanelActionBar",
        content: "engPanelContent",
        footer: "engPanelFooter"
      },
      scope: {
        title: "<"
      }
    }
  }])