angular.module("beamng.apps")
  /**
   * @ngdoc directive
   * @name beamng.apps:engProgressBar
   * @description Displays a value between (0, 1) as a progress bar in a specified colour, with a text label
   * @param {string} label The text to display as a label above the progress bar
   * @param {number} value The value  between (0, 1) to display
   * @param {boolean} [glow] Whether the value should glow
   */
  .directive("engProgressBar", [() => {
    return {
      templateUrl: "../../modules/apps/ExplosionController/components/progress-bar/progress-bar.html",
      restrict: "E",
      scope: {
        label: "<",
        value: "<",
        glow: "<"
      },
      link: $scope => {
        $scope.glow = $scope.glow || false;
      }
    };
  }])