angular.module("beamng.apps")
  /**
   * @ngdoc directive
   * @name beamng.apps:engSlide
   * @description A wrapper to an element that animates sliding in and out from a direction. The `direction` property
   * specifies the direction of the animation sliding in; the animation will slide out in the opposite direction.
   * @param {boolean} enter Whether the contents are visible and in-frame
   * @param {Direction} direction The direction the animation will enter
   * @param {boolean} [fullSize] Whether the slide animation should fit to the available space (both horizontally and
   * vertically). Optional and defaults to `false`.
   * @param {boolean} [animate] Whether the slide animation should be played at all. Defaults to `true`.
   */
  .directive("engSlide", [() => {
    return {
      templateUrl: "../../modules/apps/ExplosionController/components/slide/slide.html",
      restrict: "E",
      transclude: true,
      scope: {
        enter: "<",
        direction: "<",
        fullSize: "<",
        animate: "<"
      },
      link: ($scope) => {
        $scope.fullSize = $scope.fullSize || false;
        $scope.animate = $scope.animate || true;
      }
    }
  }])