angular.module("beamng.apps")
  /**
   * @ngdoc directive
   * @name beamng.apps:engSlider
   * @description An input slider that allows selecting a single value. along a linear axis
   * @param {string} label The label to display on the slider
   * @param {number} max The maximum value
   * @param {number} model The current value of the slider. This is updated in-place.
   * @param {number} [min] The minimum value. Defaults to `0`.
   * @param {boolean} [disabled] Whether the slider is disabled and cannot be selected
   */
  .directive("engSlider", [() => {
    return {
      templateUrl: "../../modules/apps/ExplosionController/components/slider/slider.html",
      restrict: "E",
      transclude: true,
      scope: {
        label: "<",
        max: "<",
        model: "=",
        min: "<",
        disabled: "<"
      },
      link: $scope => {
        $scope.disabled = $scope.disabled || false;
        $scope.min = $scope.min || 0;
      }
    }
  }]);