angular.module("beamng.apps")
  /**
   * @ngdoc directive
   * @name beamng.apps:engTooltip
   * @description Acts as a wrapper to an element, displaying a tooltip when hovering over the transcluded element
   * passed to it. This tooltip can additionally display an optional title before the text.
   * @param {string} text The main text to show in te tooltip
   * @param {string} [title] An optional title to display before the text
   * @param {"info" | "non-applicable"} [variant] The variant of the tooltip. Defaults to `"info"`.
   * @param {boolean} [show] Whether to show the tooltip or not. Defaults to `true`.
   */
  .directive("engTooltip", [() => {
    return {
      templateUrl: "../../modules/apps/ExplosionController/components/tooltip/tooltip.html",
      restrict: "E",
      transclude: true,
      scope: {
        title: "<",
        text: "<",
        show: "<",
        variant: "<"
      },
      link: $scope => {
        $scope.variant = $scope.variant || "info";
        $scope.show = $scope.show !== undefined ? $scope.show : true;
      }
    };
  }])