angular.module("beamng.apps")
  /**
   * @ngdoc directive
   * @name beamng.apps:engNavigatable
   * @description
   * @requires engNavigationFactory
   */
  .directive("engNavigatable", ["engNavigationFactory", engNavigationFactory => {
    return {
      link: ($scope, element) => {
        const THIS_ELEMENT = angular.element(element.children())[0];

        const focusedElementSubscription = focusedElement => {
          const isFocused = focusedElement === THIS_ELEMENT;
          THIS_ELEMENT.style.border = isFocused ? "2px solid white" : "";
        };

        function init() {
          engNavigationFactory.addNavigatableElement(THIS_ELEMENT);
          engNavigationFactory.focusedElement.subscribe(focusedElementSubscription);
        }

        /**
         * Unsubscribes from any subscribed observables
         */
        $scope.$on("$destroy", () => {
          engNavigationFactory.focusedElement.unsubscribe(focusedElementSubscription);
        });

        init();
      }
    }
  }]);