angular.module("beamng.apps")
  /**
   * @ngdoc factory
   * @name beamng.apps:engNavigationFactory
   * @description
   * @requies engObservablesFactory
   */
  .factory("engNavigationFactory", ["engObservablesFactory", (engObservablesFactory) => {

    /** @type {Observable<HTMLElement | null>} */
    const focusedElement = engObservablesFactory.newObservable(null);
    /** @type {Observable<HTMLElement[]>} */
    const focusableElements = engObservablesFactory.newObservable([]);

    // function getOffset(element) {
    //   const rectangle = element.getBoundingClientRect();
    //   return {
    //     left: rectangle.left + RELATIVE_RECTANGLE.left,
    //     top: rectangle.top + RELATIVE_RECTANGLE.top
    //   };
    // }

    function addNavigatableElement(element) {
      focusableElements.next([...focusableElements.value, element]);
    }

    function navigate(next = true) {
      const elements = focusableElements.value;
      const index = elements.indexOf(focusedElement.value);
      let nextIndex = next ? index + 1 : index - 1;

      if (nextIndex < 0 || nextIndex > elements.length - 1) nextIndex = 0;
      focusedElement.next(elements[nextIndex]);
    }

    function resetFocusableElements() {
      focusableElements.next([]);
    }

    function init() {
      // Get the containing element that BeamNG creates for the app
      const RELATIVE_ELEMENT = document.getElementById("eng-controller").parentElement.parentElement;

      // RELATIVE_ELEMENT.addEventListener("keydown", event => {
      //   navigate();
      // });
    }

    return {
      focusedElement: /** @type {Subscribable<HTMLElement | null>} */ focusedElement,
      addNavigatableElement,
      navigate,
      init,
      resetFocusableElements
    };
  }]);