angular.module("beamng.apps")
  /**
   * @ngdoc filter
   * @name beamng.apps:EngDifficulty
   * @description Translates a given difficulty id to a corresponding effect that that difficulty will have. Note that
   * this is currently implicitly tied to the boss difficulties.
   */
  .filter("EngDifficulty", () => {
    /**
     * Translates a given difficulty id to a corresponding effect that that difficulty will have.
     * Note that this is currently implicitly tied to the boss difficulties.
     * @param {Difficulty} difficulty The integer to convert
     * @returns {string} The effect of the {@link difficulty}
     * @throws Error if the {@link difficulty} is not a valid {@link Difficulty}
     */
    function transform(difficulty) {
      switch (difficulty) {
        case "easy": return "decreased";
        case "normal": return "regular";
        case "hard": return "increased";
        default: throw new Error(`${difficulty} is not supported by "EngDifficulty"`);
      }
    }

    return transform;
  });