angular.module("beamng.apps")
  /**
   * @ngdoc filter
   * @name beamng.apps:EngExplosiveValueText
   * @description Converts a {@link ConfiguredExplosive}'s [rank]{@link ExplosivePreset#rank} and
   * [tier]{@link ConfiguredExplosive#tier} into a title string.
   */
  .filter("EngExplosiveValueText", () => {
    /**
     * Returns a string text of the given explosive's [rank]{@link ExplosivePreset#rank} and
     * [tier]{@link ConfiguredExplosive#tier}.
     * @param {ConfiguredExplosive} explosive The explosive to get a text description for its rank and tier
     * @return {string} The text description
     */
    function transform(explosive) {
      const tier = explosive.tier;
      const rank = explosive.preset.rank;
      return `Explosive Rank ${rank} [Tier ${tier}]`;
    }

    return transform;
  });