angular.module("beamng.apps")
  /**
   * @ngdoc filter
   * @name beamng.apps:EngRomanNumerals
   * @description Converts an integer into its corresponding roman numeral. Supports numbers from (1-5).
   */
  .filter("EngRomanNumerals", () => {
    /**
     * Converts the given integer into its corresponding roman numeral.
     * Supports value between (1, 5).
     * @param {number} input The integer to convert
     * @returns {string} The roman numeral of {@link input}
     * @throws Error if the {@link input} is not an integer between (1, 5)
     */
    function transform(input) {
      switch (input) {
        case 1: return "I";
        case 2: return "II";
        case 3: return "III";
        case 4: return "IV";
        case 5: return "V";
        default: throw new Error(`${input} is not supported by "EngRomanNumerals"`);
      }
    }

    return transform;
  });