# Testing Scenarios
Testing scenarios that should be manually run.
These are defined in the standard Given, When, Then syntax.

### Scenario: creating default new explosive
- When I click the + button
- Then the explosive view is shown
- When I click the next button
- Then the place explosive panel is shown
- And the preview is shown
- When I click the place button
- Then the explosive is added
- And the overview panel is shown
- And the preview is hidden

### Scenario: creating non-default explosive 
- When I click the + button
- Then the explosive view is shown
- When I click the explosive next button (n times)
- And I click the preset next button (n times)
- And I click the next button
- Then the place explosive panel is shown
- And the preview is shown
- When I click the place button
- Then the explosive is added
- And the overview panel is shown
- And the preview is hidden

### Scenario: creating new The Convergence explosive
- When I click the + button
- Then the explosive view is shown
- When I navigate to the The Convergence explosive
- When I click the next button
- Then the place explosive panel is shown
- And the preview is shown
- When I click the place button
- Then the The Convergence popup is shown
- When I click the Close and Place button
- Then the explosive is added
- And the overview panel is shown
- And the preview is hidden

### Scenario: creating new explosive with no vehicle present
- When I click the + button
- Then the explosive view is shown
- When I click the next button
- Then the place explosive panel is shown
- And the preview is shown
- And the Place at Vehicle Location option is disabled
- When I click the place button
- Then the explosive is added
- And the overview panel is shown
- And the preview is hidden

### Scenario: updating existing explosive
- Given I have configured an explosive
- And I am on the overview view
- When I click the explosive
- Then the place explosive panel is shown
- And the preview is shown
- When I click the overlay
- Then the explosive panel is shown
- And the preview is hidden
- When I click the explosive next button (n times)
- And I click the next button
- Then the place explosive panel is shown
- And the preview is shown
- When I click the place button
- Then the explosive is added
- And the overview panel is shown
- And the preview is hidden

### Scenario: updating existing explosive without changing anything
- Given I have configured an explosive
- And I am on the overview view
- When I click the explosive
- Then the place explosive panel is shown
- When I click the place button
- Then the explosive is added
- And the overview panel is shown
- And the preview is hidden

### Scenario: deleting existing explosive
- Given I have configured an explosive
- And I am on the overview panel
- When I click the delete button
- Then the explosive is removed

### Scenario: viewing existing explosive
- Given I have configured an explosive
- And I am on the overview panel
- When I click the view button
- Then the preview is shown
- When I click the view button
- Then the preview is hidden

### Scenario: deleting existing explosive that is being viewed
- Given I have configured an explosive
- And I am on the overview panel
- And the preview is shown
- When I click the delete button
- Then the explosive is removed
- And the preview is hidden

### Scenario: opening existing explosive that is currently viewed
- Given I have configured an explosive
- And I am on the overview panel
- When I click the view button
- Then the explosive is shown
- When I click the explosive
- Then the place explosive panel is shown
- And only one preview is shown

### Scenario: opening one explosive from multiple configured ones that are currently viewed
- Given I have configured more than one explosive
- And I am on the overview panel
- When I click the view button of both explosives
- Then the explosives are shown
- When I click the explosive
- Then the place explosive panel is shown
- And only one preview is shown

### Scenario: updating coordinates by different types
- When I click the + button
- Then the explosive view is shown
- When I click the next button
- Then the place explosive panel is shown
- And the preview is shown
- When I move the vehicle
- And I click the reset button
- Then the preview is updated
- When I change the coordinate type to camera location
- Then the preview is updated
- When I move the camera
- And I click the reset button
- Then the preview is updated

### Scenario: refresh the UI after it is deleted
- Given I have configured an explosive
- When I press the escape key
- Then the UI is destroyed
- When I press the escape key
- Then the UI is shown
- And the configuration is persisted
- When I click the explosive
- Then the place explosive panel is shown
- And the preview is shown
- When I press the escape key
- Then the UI is destroyed
- When I press the escape key
- Then the UI is shown
- And the place explosive panel is shown
- When I click the overlay
- Then the explosive panel is shown
- When I press the escape key
- Then the UI is destroyed
- When I press the escape key
- Then the explosive panel is shown

### Scenario: refresh the UI after it is deleted with previews shown
- Given I have configured more than one explosive
- And their previews are shown
- When I press the escape key
- Then the UI is destroyed
- When I press the escape key
- Then the UI is shown
- And the previews are shown on the overview page